<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: inc/coopBendersSubproblemL1.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_bfccd401955b95cf8c75461437045ac0.html">inc</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">coopBendersSubproblemL1.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="coop_benders_subproblem_l1_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**********************************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2021 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * This program and the accompanying materials are made available under the</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> **********************************************************************************/</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;gurobi_c++.h&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;numeric&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="exceptions_8hpp.html">exceptions.hpp</a>&quot;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="input_structs_8hpp.html">inputStructs.hpp</a>&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="dyn_array_raii_wrapper_8hpp.html">dynArrayRaiiWrapper.hpp</a>&quot;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>decoop {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html">   34</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html">PlantbusSubproblemL1</a> {</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#af6cd150f833e021a84629a8e076abc85">   35</a></span>&#160;        <span class="keyword">const</span> <a class="code" href="structdecoop_1_1_subproblem_options.html">SubproblemOptions</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#af6cd150f833e021a84629a8e076abc85">options_</a>;           </div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65">   36</a></span>&#160;        GRBModel <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65">model_</a>;                            </div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9">   37</a></span>&#160;        <a class="code" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper&lt;GRBConstr&gt;</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9">equations_</a>;  </div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58">   38</a></span>&#160;        <a class="code" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper&lt;GRBVar&gt;</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58">variables_</a>;     </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a99b120c226955c114d1185d36b688f90">   39</a></span>&#160;        <span class="keyword">const</span> std::string <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a99b120c226955c114d1185d36b688f90">coupling_equation_name_</a>;  </div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e">   40</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e">coupling_equation_</a>;        </div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e">   41</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e">constraints_</a>;              </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03">   42</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03">model_vars_</a>;               </div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd">   43</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd">n_slack_</a>;                  </div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b">   44</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b">p_slack_</a>;                  </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab3b35f0a6fea154a107e94af1636a656">   46</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab3b35f0a6fea154a107e94af1636a656">num_timesteps_</a>;              </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a0ce86dc580bf5272c19c827666e0d8db">   47</a></span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a0ce86dc580bf5272c19c827666e0d8db">pow_sugg_</a>;              </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#a83a18d62c3ee10bbb65ea93797242b29">   48</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a83a18d62c3ee10bbb65ea93797242b29">plant_load_</a>;                   </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae1a79636eb368c63b73ce3d5e5d7b478">   50</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae1a79636eb368c63b73ce3d5e5d7b478">rhs_num_records_</a>;       </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab119d790de2b3b817927acfa1d2e314e">InitObject</a>();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a5f8dfc0bca82b1f5aae9b854f2608578">PlantbusSubproblemL1</a>(<span class="keyword">const</span> GRBEnv&amp; env, <span class="keyword">const</span> std::string&amp; option_path, <span class="keyword">const</span> <span class="keywordtype">double</span> plant_load, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> num_timesteps);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6de9f886669346f05746dd6b22e768f1">Solve</a>();</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4b94c28d900106779deb55571355bcc">GetModelStatus</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a91ffead887f3d8961ca6d787b93168d9">GetNewRhs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a463a29b7d2cf7b121cb9b5c69992cb98">GetCurrLhs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9aa900dfe5f0882030abd72a7a7f7a">GetNewCoeff</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a86935d2f7bdf0caf1f0d1b9ee6ccb7df">GetNewCoeffs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a148da0d8b1e81458343ad5e95b38ecec">GetSubproblemObjective</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2573240404d563487c1f25829b3b4eb9">GenerateAndVerifyCut</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2d937ee5b1256ebfff0f5a79f792d98c">get_plant_load</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae4531793f2eec41039c4be4905eec28e">ComputeFeasDistance</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a590527bb3ccf8a97aeb320c1d54b5dd5">ComputeFeasSol</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a590527bb3ccf8a97aeb320c1d54b5dd5">ComputeFeasSol</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a338929b552e8af9a7612f3bb4ae12a32">GetNSlackValues</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab8a27c2b34a6bef9695e76b42c6a62f3">GetPSlackValues</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a973d94c4cd81963a10dd736488044d16">get_pow_sugg</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#a973d94c4cd81963a10dd736488044d16">get_pow_sugg</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> i) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#aad54229e7d85a7a6cb8cf2eeb56a169a">set_pow_sugg</a>(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; in);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#aad54229e7d85a7a6cb8cf2eeb56a169a">set_pow_sugg</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key, <span class="keyword">const</span> <span class="keywordtype">double</span> val);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        GRBModel&amp; <a class="code" href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4ddb1eaeeb0a48bcd5a06c36586efe5">GetModel</a>();</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    };</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;} <span class="comment">//namespace decoop</span></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a338929b552e8af9a7612f3bb4ae12a32"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a338929b552e8af9a7612f3bb4ae12a32">decoop::PlantbusSubproblemL1::GetNSlackValues</a></div><div class="ttdeci">std::vector&lt; double &gt; GetNSlackValues() const </div><div class="ttdoc">Returns values of negative slack variables. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:194</div></div>
<div class="ttc" id="dyn_array_raii_wrapper_8hpp_html"><div class="ttname"><a href="dyn_array_raii_wrapper_8hpp.html">dynArrayRaiiWrapper.hpp</a></div><div class="ttdoc">Header file for DynArrayRAIIWrapper class. </div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ac4ddb1eaeeb0a48bcd5a06c36586efe5"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4ddb1eaeeb0a48bcd5a06c36586efe5">decoop::PlantbusSubproblemL1::GetModel</a></div><div class="ttdeci">GRBModel &amp; GetModel()</div><div class="ttdoc">Returns reference to model_ object. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:225</div></div>
<div class="ttc" id="structdecoop_1_1_subproblem_options_html"><div class="ttname"><a href="structdecoop_1_1_subproblem_options.html">decoop::SubproblemOptions</a></div><div class="ttdoc">Processes user input from file options_subproblem.txt. </div><div class="ttdef"><b>Definition:</b> inputStructs.hpp:95</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a0ce86dc580bf5272c19c827666e0d8db"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a0ce86dc580bf5272c19c827666e0d8db">decoop::PlantbusSubproblemL1::pow_sugg_</a></div><div class="ttdeci">std::vector&lt; double &gt; pow_sugg_</div><div class="ttdoc">Power profile suggestion. Unit is multiples of flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:47</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_af6cd150f833e021a84629a8e076abc85"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#af6cd150f833e021a84629a8e076abc85">decoop::PlantbusSubproblemL1::options_</a></div><div class="ttdeci">const SubproblemOptions options_</div><div class="ttdoc">Holds options specified by user in option file. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:35</div></div>
<div class="ttc" id="input_structs_8hpp_html"><div class="ttname"><a href="input_structs_8hpp.html">inputStructs.hpp</a></div><div class="ttdoc">Header file for structs used to process user input from option files. </div></div>
<div class="ttc" id="exceptions_8hpp_html"><div class="ttname"><a href="exceptions_8hpp.html">exceptions.hpp</a></div><div class="ttdoc">Header file for custom exception classes. </div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ae2ec2c96547283c1752defa3e52633bd"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd">decoop::PlantbusSubproblemL1::n_slack_</a></div><div class="ttdeci">std::vector&lt; int &gt; n_slack_</div><div class="ttdoc">Indices of all entries in variables_ that are negative slack variables. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:43</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ab46930555472c4d857991655324ccb65"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65">decoop::PlantbusSubproblemL1::model_</a></div><div class="ttdeci">GRBModel model_</div><div class="ttdoc">L1 subproblem model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:36</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a98c6106ebbbb2c77cb35b06125236bb9"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9">decoop::PlantbusSubproblemL1::equations_</a></div><div class="ttdeci">DynArrayRAIIWrapper&lt; GRBConstr &gt; equations_</div><div class="ttdoc">All equations part of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:37</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a83a18d62c3ee10bbb65ea93797242b29"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a83a18d62c3ee10bbb65ea93797242b29">decoop::PlantbusSubproblemL1::plant_load_</a></div><div class="ttdeci">const double plant_load_</div><div class="ttdoc">Flexible load of this subproblem in MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:48</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_aad54229e7d85a7a6cb8cf2eeb56a169a"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#aad54229e7d85a7a6cb8cf2eeb56a169a">decoop::PlantbusSubproblemL1::set_pow_sugg</a></div><div class="ttdeci">void set_pow_sugg(const std::vector&lt; double &gt; &amp;in)</div><div class="ttdoc">Sets power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:221</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a2d937ee5b1256ebfff0f5a79f792d98c"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a2d937ee5b1256ebfff0f5a79f792d98c">decoop::PlantbusSubproblemL1::get_plant_load</a></div><div class="ttdeci">double get_plant_load() const </div><div class="ttdoc">Returns flexible load of this subproblem in MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:174</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a91ffead887f3d8961ca6d787b93168d9"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a91ffead887f3d8961ca6d787b93168d9">decoop::PlantbusSubproblemL1::GetNewRhs</a></div><div class="ttdeci">double GetNewRhs() const </div><div class="ttdoc">Computes right hand side of the cut generated from current power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:81</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a26dd14ef78bb1a3c7bc9fe722fef0f58"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58">decoop::PlantbusSubproblemL1::variables_</a></div><div class="ttdeci">DynArrayRAIIWrapper&lt; GRBVar &gt; variables_</div><div class="ttdoc">All variables part of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:38</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a99b120c226955c114d1185d36b688f90"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a99b120c226955c114d1185d36b688f90">decoop::PlantbusSubproblemL1::coupling_equation_name_</a></div><div class="ttdeci">const std::string coupling_equation_name_</div><div class="ttdoc">Name of the equation coupling master power suggestion and feasible profile computed in subproblem...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:39</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a86935d2f7bdf0caf1f0d1b9ee6ccb7df"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a86935d2f7bdf0caf1f0d1b9ee6ccb7df">decoop::PlantbusSubproblemL1::GetNewCoeffs</a></div><div class="ttdeci">std::vector&lt; double &gt; GetNewCoeffs() const </div><div class="ttdoc">Computes all coefficients of the left hand side of the cut. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:134</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ae1a79636eb368c63b73ce3d5e5d7b478"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ae1a79636eb368c63b73ce3d5e5d7b478">decoop::PlantbusSubproblemL1::rhs_num_records_</a></div><div class="ttdeci">const unsigned long rhs_num_records_</div><div class="ttdoc">Number of terms used to compute scalar product on right hand side of a cut. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:50</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a148da0d8b1e81458343ad5e95b38ecec"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a148da0d8b1e81458343ad5e95b38ecec">decoop::PlantbusSubproblemL1::GetSubproblemObjective</a></div><div class="ttdeci">double GetSubproblemObjective() const </div><div class="ttdoc">Returns objective value of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:143</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ae4531793f2eec41039c4be4905eec28e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ae4531793f2eec41039c4be4905eec28e">decoop::PlantbusSubproblemL1::ComputeFeasDistance</a></div><div class="ttdeci">double ComputeFeasDistance() const </div><div class="ttdoc">Computes distance between suggested power profile and the feasible profile found by the subproblem...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:178</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a590527bb3ccf8a97aeb320c1d54b5dd5"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a590527bb3ccf8a97aeb320c1d54b5dd5">decoop::PlantbusSubproblemL1::ComputeFeasSol</a></div><div class="ttdeci">std::vector&lt; double &gt; ComputeFeasSol() const </div><div class="ttdoc">Computes the feasible power profile found by the subproblem. Unit is MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:182</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ab8a27c2b34a6bef9695e76b42c6a62f3"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ab8a27c2b34a6bef9695e76b42c6a62f3">decoop::PlantbusSubproblemL1::GetPSlackValues</a></div><div class="ttdeci">std::vector&lt; double &gt; GetPSlackValues() const </div><div class="ttdoc">Returns values of positive slack variables. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:202</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a463a29b7d2cf7b121cb9b5c69992cb98"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a463a29b7d2cf7b121cb9b5c69992cb98">decoop::PlantbusSubproblemL1::GetCurrLhs</a></div><div class="ttdeci">double GetCurrLhs() const </div><div class="ttdoc">Computes value of the left hand side of the generated cut when current power profile suggestion is in...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:118</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_abc8fb896970fdcf7b656bbb29dcff49e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e">decoop::PlantbusSubproblemL1::constraints_</a></div><div class="ttdeci">std::vector&lt; int &gt; constraints_</div><div class="ttdoc">Indices of all entries in equations_ that are not a coupling equation. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:41</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a973d94c4cd81963a10dd736488044d16"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a973d94c4cd81963a10dd736488044d16">decoop::PlantbusSubproblemL1::get_pow_sugg</a></div><div class="ttdeci">std::vector&lt; double &gt; get_pow_sugg() const </div><div class="ttdoc">Returns power profile suggestion. Unit is multiples of flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:210</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a2573240404d563487c1f25829b3b4eb9"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a2573240404d563487c1f25829b3b4eb9">decoop::PlantbusSubproblemL1::GenerateAndVerifyCut</a></div><div class="ttdeci">double GenerateAndVerifyCut() const </div><div class="ttdoc">Computes right hand side of the cut, verifies its correctness and ensures that current power profile ...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:147</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html">decoop::PlantbusSubproblemL1</a></div><div class="ttdoc">Provides an interface for solving L1 subproblems and adding cuts from such problems. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:34</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a6e9d84692dcec80f37e39dc5ca5fcb5b"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b">decoop::PlantbusSubproblemL1::p_slack_</a></div><div class="ttdeci">std::vector&lt; int &gt; p_slack_</div><div class="ttdoc">Indices of all entries in variables_ that are positive slack variables. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:44</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ab21709857572f155cb0a25abbbaa354e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e">decoop::PlantbusSubproblemL1::coupling_equation_</a></div><div class="ttdeci">std::vector&lt; int &gt; coupling_equation_</div><div class="ttdoc">Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:40</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ab119d790de2b3b817927acfa1d2e314e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ab119d790de2b3b817927acfa1d2e314e">decoop::PlantbusSubproblemL1::InitObject</a></div><div class="ttdeci">unsigned long InitObject()</div><div class="ttdoc">Fills coupling_equation_, constraints_, model_vars_, n_slack_ and p_slack_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:21</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a6de9f886669346f05746dd6b22e768f1"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a6de9f886669346f05746dd6b22e768f1">decoop::PlantbusSubproblemL1::Solve</a></div><div class="ttdeci">void Solve()</div><div class="ttdoc">Solves the subproblem with the currently held power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:57</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ac4b94c28d900106779deb55571355bcc"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4b94c28d900106779deb55571355bcc">decoop::PlantbusSubproblemL1::GetModelStatus</a></div><div class="ttdeci">int GetModelStatus() const </div><div class="ttdoc">Returns status code of the model_. See Gurobi reference manual for meaning of codes. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:73</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_ab3b35f0a6fea154a107e94af1636a656"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#ab3b35f0a6fea154a107e94af1636a656">decoop::PlantbusSubproblemL1::num_timesteps_</a></div><div class="ttdeci">const unsigned num_timesteps_</div><div class="ttdoc">Number of timesteps in the model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:46</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a2bc98f8ace120aa946f6fde01ca31a03"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03">decoop::PlantbusSubproblemL1::model_vars_</a></div><div class="ttdeci">std::vector&lt; int &gt; model_vars_</div><div class="ttdoc">Indices of all entries in variables_ that are part of the plant model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.hpp:42</div></div>
<div class="ttc" id="classdecoop_1_1_dyn_array_r_a_i_i_wrapper_html"><div class="ttname"><a href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper&lt; GRBConstr &gt;</a></div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a5f8dfc0bca82b1f5aae9b854f2608578"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a5f8dfc0bca82b1f5aae9b854f2608578">decoop::PlantbusSubproblemL1::PlantbusSubproblemL1</a></div><div class="ttdeci">PlantbusSubproblemL1(const GRBEnv &amp;env, const std::string &amp;option_path, const double plant_load, const unsigned num_timesteps)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:47</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_l1_html_a6e9aa900dfe5f0882030abd72a7a7f7a"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9aa900dfe5f0882030abd72a7a7f7a">decoop::PlantbusSubproblemL1::GetNewCoeff</a></div><div class="ttdeci">double GetNewCoeff(const unsigned key) const </div><div class="ttdoc">Computes coefficient of the left hand side of the cut for a given timestep. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemL1.cpp:129</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
